/* Problem URL: https://codeforces.com/problemset/problem/1923/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n;
    cin >> n;
    vl a(n);
    cin >> a;

    vl pref(n + 1);
    nrep(i, 1, n + 1) {
        pref[i] = pref[i - 1] + a[i - 1];
    }

    vvi sparse(20, vi(n - 1));
    rep(i, n - 1) {
        sparse[0][i] = a[i] != a[i + 1];
    }

    nrep(j, 1, 20) {
        for (int i = 0; i + (1 << (j - 1)) < n - 1; i++) {
            sparse[j][i] = sparse[j - 1][i] | sparse[j - 1][i + (1 << (j - 1))];
        }
    }

    auto query = [&](int l, int r) {
        int log = 31 - __builtin_clz(r - l + 1);
        return sparse[log][l] | sparse[log][r - (1 << log) +  1];
    };

    rep(i, n) {
        if (i > 0 && a[i - 1] > a[i]) {
            cout << "1 ";
            continue;
        }

        if (i < n - 1 && a[i + 1] > a[i]) {
            cout << "1 ";
            continue;
        }

        auto calcbf = [&]() {
            int low = 0;
            int high = i - 2;
            int ans = oo;
            while (low <= high) {
                int mid = (low + high) >> 1;

                if (!query(mid, i - 2) || pref[i] - pref[mid] <= a[i]) {
                    high = mid - 1;
                    continue;
                }

                low = mid + 1;
                ans = i - mid;
            }

            return ans;
        };

        auto calcnx = [&]() {
            int low = i + 2;
            int high = n - 1;
            int ans = oo;
            while (low <= high) {
                int mid = (low + high) >> 1;

                if (!query(i + 1, mid - 1) || pref[mid + 1] - pref[i + 1] <= a[i]) {
                    low = mid + 1;
                    continue;
                }

                high = mid - 1;
                ans = mid - i;
            }

            return ans;
        };

        int ans = min(calcbf(), calcnx());
        if (ans == oo) {
            cout << "-1 ";
            continue;
        }

        cout << ans << ' ';
    }
    cout << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
